#ifndef __matrix_h
#define __matrix_h

#define ZERO 0.00000000000000000000001

/*******************************************************/
/**************** 2D matrix of integers ****************/
/*******************************************************/
struct TMatrix{
	long row;
	long column;
	int **data;
};
typedef struct TMatrix  MATRIX;

MATRIX allocateMatrix(long row, long column);
void freeMatrix(MATRIX M);
void initializeMatrix(MATRIX *M, int c);

int maxMatrixEntry(MATRIX M);
/*******************************************************/
/**************** 2D matrix of doubles *****************/
/*******************************************************/
struct TMatrixD{
	long row;
	long column;
	double **data;
};
typedef struct TMatrixD MATRIXD;

MATRIXD allocateMatrixD(long row, long column);
void freeMatrixD(MATRIXD M);
/*******************************************************/
/**************** 3D matrix of integers ****************/
/*******************************************************/
struct TMatrix3{
	long d1, d2, d3;
	int ***data;
};
typedef struct TMatrix3  MATRIX3;

MATRIX3 allocateMatrix3(long d1, long d2, long d3);
void freeMatrix3(MATRIX3 M);
void initializeMatrix3(MATRIX3 *M, int c);
/*******************************************************/
/*******************************************************/
/*******************************************************/
MATRIX findConnectedComponents(MATRIX im);

#endif
